## gwyprocessenums gwyprocessenums — Common enumerations |

## Functions

const GwyEnum * | gwy_merge_type_get_enum ()
const GwyEnum * | gwy_masking_type_get_enum ()
const GwyEnum * | gwy_plane_symmetry_get_enum ()
const GwyEnum * | gwy_2d_cwt_wavelet_type_get_enum ()
const GwyEnum * | gwy_orientation_get_enum ()
const GwyEnum * | gwy_dwt_type_get_enum ()
const GwyEnum * | gwy_dwt_denoise_type_get_enum ()
const GwyEnum * | gwy_interpolation_type_get_enum ()
const GwyEnum * | gwy_windowing_type_get_enum ()
const GwyEnum * | gwy_correlation_type_get_enum ()
const GwyEnum * | gwy_distance_transform_type_get_enum ()
gint | gwy_computation_state_get_state ()
gdouble | gwy_computation_state_get_fraction ()

## Types and Values

enum | GwyMergeType
enum | GwyMaskingType
enum | GwyWatershedStateType
enum | GwyPlaneSymmetry
enum | Gwy2DCWTWaveletType
enum | GwyOrientation
enum | GwyTransformDirection
enum | GwyDataFieldCached
enum | GwyComputationStateType
enum | GwyDWTType
enum | GwyDWTDenoiseType
enum | GwyInterpolationType
enum | GwyPlaneFitQuantity
enum | GwyWindowingType
enum | GwyTipType
enum | GwyTipParamType
enum | GwyCorrelationType
enum | GwyCorrSearchType
enum | GwyGrainQuantity
enum | GwyDataCompatibilityFlags
enum | GwyLineStatQuantity
enum | GwyExteriorType
enum | GwyDistanceTransformType
enum | GwyMinMaxFilterType
enum | GwyRotateResizeType
enum | GwyAffineScalingType
enum | GwyBrickTransposeType
| GwyComputationState

## Object Hierarchy

        gpointer
        ╰── GwyComputationState

## Includes

    #include <libprocess/gwyprocess.h>

## Description

## Functions

### gwy_merge_type_get_enum ()

    const GwyEnum *
    gwy_merge_type_get_enum (void);

Returns GwyEnum for GwyMergeType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_masking_type_get_enum ()

    const GwyEnum *
    gwy_masking_type_get_enum (void);

Returns GwyEnum for GwyMaskingType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

Since: 2.18

### gwy_plane_symmetry_get_enum ()

    const GwyEnum *
    gwy_plane_symmetry_get_enum (void);

Returns GwyEnum for GwyPlaneSymmetry enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_2d_cwt_wavelet_type_get_enum ()

    const GwyEnum *
    gwy_2d_cwt_wavelet_type_get_enum (void);

Returns GwyEnum for Gwy2DCWTWaveletType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_orientation_get_enum ()

    const GwyEnum *
    gwy_orientation_get_enum (void);

Returns GwyEnum for GwyOrientation enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_dwt_type_get_enum ()

    const GwyEnum *
    gwy_dwt_type_get_enum (void);

Returns GwyEnum for GwyDWTType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_dwt_denoise_type_get_enum ()

    const GwyEnum *
    gwy_dwt_denoise_type_get_enum (void);

Returns GwyEnum for GwyDWTDenoiseType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_interpolation_type_get_enum ()

    const GwyEnum *
    gwy_interpolation_type_get_enum (void);

Returns GwyEnum for GwyInterpolationType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_windowing_type_get_enum ()

    const GwyEnum *
    gwy_windowing_type_get_enum (void);

Returns GwyEnum for GwyWindowingType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_correlation_type_get_enum ()

    const GwyEnum *
    gwy_correlation_type_get_enum (void);

Returns GwyEnum for GwyCorrelationType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

### gwy_distance_transform_type_get_enum ()

    const GwyEnum *
    gwy_distance_transform_type_get_enum (void);

Returns GwyEnum for GwyDistanceTransformType enum type.

#### Returns

`NULL`-terminated GwyEnum which must not be modified nor freed.

Since: 2.43

### gwy_computation_state_get_state ()

    gint
    gwy_computation_state_get_state (GwyComputationState *compstate);

Gets the state field of a computation state struct.

Useful mostly for language bindings.

#### Parameters

compstate | Computation state. |

#### Returns

The state field of `compstate` .

Since: 2.49

### gwy_computation_state_get_fraction ()

    gdouble
    gwy_computation_state_get_fraction (GwyComputationState *compstate);

Gets the fraction field of a computation state struct.

#### Parameters

compstate | Computation state. |

#### Returns

The fraction field of `compstate` .

Since: 2.49

## Types and Values

### enum GwyMergeType

Mask merge type (namely used in grain processing).

#### Members

GWY_MERGE_UNION | Union (logical or) merging. |
GWY_MERGE_INTERSECTION | Intersection (logical and) merging. |

### enum GwyMaskingType

Mask handling in procedures that can apply masking.

Note at present many procedures do not have a masking argument and hence cannot apply masks in exclude mode.

#### Members

GWY_MASK_EXCLUDE | Exclude data under mask, i.e. take into account only data not covered by the mask. |
GWY_MASK_INCLUDE | Take into account only data under the mask. |
GWY_MASK_IGNORE | Ignore mask, if present, and use all data. |

Since: 2.12

### enum GwyWatershedStateType

#### Members

GWY_WATERSHED_STATE_INIT |  |
GWY_WATERSHED_STATE_LOCATE |  |
GWY_WATERSHED_STATE_MIN |  |
GWY_WATERSHED_STATE_WATERSHED |  |
GWY_WATERSHED_STATE_MARK |  |
GWY_WATERSHED_STATE_FINISHED |  |

### enum GwyPlaneSymmetry

Plane symmetry types for rotation correction.

#### Members

GWY_SYMMETRY_AUTO | Automatic symmetry selection. |
GWY_SYMMETRY_PARALLEL | Parallel symmetry, there is one prevalent direction (bilateral). |
GWY_SYMMETRY_TRIANGULAR | Triangular symmetry, there are three prevalent directions (unilateral) by 120 degrees. |
GWY_SYMMETRY_SQUARE | Square symmetry, two prevalent directions (bilateral) oriented approximately along image sides. |
GWY_SYMMETRY_RHOMBIC | Rhombic symmetry, two prevalent directions (bilateral) oriented approximately along diagonals. |
GWY_SYMMETRY_HEXAGONAL | Hexagonal symmetry, three prevalent directions (bilateral) by 120 degrees. |
GWY_SYMMETRY_LAST | The number of symmetries. |

### enum Gwy2DCWTWaveletType

#### Members

GWY_2DCWT_GAUSS |  |
GWY_2DCWT_HAT |  |

### enum GwyOrientation

Orientation type.

#### Members

GWY_ORIENTATION_HORIZONTAL | Horizontal orientation. |
GWY_ORIENTATION_VERTICAL | Vertical orientation. |

### enum GwyTransformDirection

Transform (namely integral transform) direction.

In FFT, it is equal to sign of the exponent, that is the backward transform uses -1, the forward transform +1. This is the opposite sign convention to FFTW (for instance), so care must be taken when mixing operations.

#### Members

GWY_TRANSFORM_DIRECTION_BACKWARD | Backward (inverse) transform. |
GWY_TRANSFORM_DIRECTION_FORWARD | Forward (direct) transform. |

### enum GwyDataFieldCached

Cached data field quantity type.

There should be little need to this enum directly except in libgwyprocess methods.

#### Members

GWY_DATA_FIELD_CACHE_MIN | Overall minimum. |
GWY_DATA_FIELD_CACHE_MAX | Overall maximum. |
GWY_DATA_FIELD_CACHE_SUM | Sum of all values. |
GWY_DATA_FIELD_CACHE_RMS | Root mean square. |
GWY_DATA_FIELD_CACHE_MED | Median. |
GWY_DATA_FIELD_CACHE_ARF | Auto-range from. |
GWY_DATA_FIELD_CACHE_ART | Auto-range to. |
GWY_DATA_FIELD_CACHE_ARE | Surface area. |
GWY_DATA_FIELD_CACHE_VAR | Variation. |
GWY_DATA_FIELD_CACHE_ENT | Entropy. |
GWY_DATA_FIELD_CACHE_MSQ | Mean square. |
GWY_DATA_FIELD_CACHE_SIZE | The size of statistics cache. |

### enum GwyComputationStateType

Common iterative computation iterator state type.

#### Members

GWY_COMPUTATION_STATE_INIT | Iterator was set up, the next step will actually create temporary data structures and precalculate values. |
GWY_COMPUTATION_STATE_ITERATE | Iteration is in progress, the `fraction` field of state struct holds the fraction completed. |
GWY_COMPUTATION_STATE_FINISHED | Calculation has been finished, further calls to the iterator will be no-op. |

### enum GwyDWTType

#### Members

GWY_DWT_HAAR |  |
GWY_DWT_DAUB4 |  |
GWY_DWT_DAUB6 |  |
GWY_DWT_DAUB8 |  |
GWY_DWT_DAUB12 |  |
GWY_DWT_DAUB20 |  |

### enum GwyDWTDenoiseType

#### Members

GWY_DWT_DENOISE_UNIVERSAL |  |
GWY_DWT_DENOISE_SCALE_ADAPTIVE |  |
GWY_DWT_DENOISE_SPACE_ADAPTIVE |  |

### enum GwyInterpolationType

Interpolation types.

#### Members

GWY_INTERPOLATION_NONE | No interpolation at all, resulting values are not defined, it must not be used for interpolation. It can be used in resize operations discarding original data. |
GWY_INTERPOLATION_ROUND | Round interpolation (more precisely symmetric nearest neighbour interpolation). |
GWY_INTERPOLATION_LINEAR | Linear interpolation. |
GWY_INTERPOLATION_BILINEAR | Old name for `GWY_INTERPOLATION_LINEAR`. This is a misnomer because it in fact denotes linear interpolation of arbitrary dimension. Use `GWY_INTERPOLATION_LINEAR` instead. |
GWY_INTERPOLATION_KEY | Cubic Key's interpolation (with a=-1/2). |
GWY_INTERPOLATION_BSPLINE | B-spline interpolation. |
GWY_INTERPOLATION_OMOMS | Omoms interpolation. |
GWY_INTERPOLATION_NNA | Nearest neighbour approximation. |
GWY_INTERPOLATION_SCHAUM | Cubic Schaum interpolation. |

### enum GwyPlaneFitQuantity

Local plane fitting quantity to request from `gwy_data_field_area_fit_local_planes()` and similar functions.

#### Members

GWY_PLANE_FIT_A | Constant coefficient (mean value). |
GWY_PLANE_FIT_BX | Linear coefficient in `x` , where `x` is in pixel coordinates. |
GWY_PLANE_FIT_BY | Linear coefficient in `y` , where `y` is in pixel coordinates. |
GWY_PLANE_FIT_ANGLE | Slope orientation in (x,y) plane (in radians). |
GWY_PLANE_FIT_SLOPE | Absolute slope value (that is sqrt(bx*bx + by*by)). |
GWY_PLANE_FIT_S0 | Residual sum of squares. |
GWY_PLANE_FIT_S0_REDUCED | Slope-reduced residual sum of squares. |

### enum GwyWindowingType

Frequency windowing type.

#### Members

GWY_WINDOWING_NONE | No windowing is applied. |
GWY_WINDOWING_HANN | Hann window. |
GWY_WINDOWING_HAMMING | Hamming window. |
GWY_WINDOWING_BLACKMANN | Blackmann window. |
GWY_WINDOWING_LANCZOS | Lanczos window. |
GWY_WINDOWING_WELCH | Welch window. |
GWY_WINDOWING_RECT | Rectangular window. |
GWY_WINDOWING_NUTTALL | Nuttall window (Since 2.7). |
GWY_WINDOWING_FLAT_TOP | Flat-top window (Since 2.7). |
GWY_WINDOWING_KAISER25 | Kaiser window with β=2.5 (Since 2.7). |

### enum GwyTipType

Type of tip shape presets.

#### Members

GWY_TIP_PYRAMID | N-sided pyramidal tip. |
GWY_TIP_PYRAMIDE | Legacy name for `GWY_TIP_PYRAMID`. |
GWY_TIP_CONTACT | Four-sided pyramidal tip. |
GWY_TIP_NONCONTACT | Three-sided pyramidal tip. |
GWY_TIP_DELTA | Delta function (single-pixel tip). |
GWY_TIP_PARABOLA | Parabolic tip. (Since 2.45) |
GWY_TIP_CONE | Conical tip. (Since 2.45) |
GWY_TIP_ELLPARABOLA | Elliptical parabola tip. (Since 2.47) |
GWY_TIP_BALL_ON_STICK | Spherical tip at the end of almost-cyliner. (Since 2.50) |

### enum GwyTipParamType

Type of tip model preset parameter.

This enum is used with the new tip preset functions `gwy_tip_model_get_preset_params()`, `gwy_tip_model_preset_create()`, `gwy_tip_model_preset_create_for_zrange()`.

#### Members

GWY_TIP_PARAM_HEIGHT | Total tip height. This is used only in the delta function tip; for all others it is implied. |
GWY_TIP_PARAM_RADIUS | Radius of curvature of the tip apex. |
GWY_TIP_PARAM_ROTATION | Rotation angle. |
GWY_TIP_PARAM_NSIDES | Number of sides for pyramidal tips. |
GWY_TIP_PARAM_SLOPE | Half-angle of the apex (complement of the side slope for straight sides). |
GWY_TIP_PARAM_ANISOTROPY | Ratio between larger and smaller tip width in two orthotonal directions. |

Since: 2.47

### enum GwyCorrelationType

#### Members

GWY_CORRELATION_NORMAL |  |
GWY_CORRELATION_FFT |  |
GWY_CORRELATION_POC |  |

### enum GwyCorrSearchType

Type of correlation search output.

#### Members

GWY_CORR_SEARCH_COVARIANCE_RAW | Raw average of data values multiplied by kernel values. |
GWY_CORR_SEARCH_COVARIANCE | Local mean value is subtracted from data before kernel multiplication. |
GWY_CORR_SEARCH_COVARIANCE_SCORE | In addition, result is normalised by dividing by the local variance. |
GWY_CORR_SEARCH_HEIGHT_DIFF_RAW | Raw mean square difference between data and kernel values. |
GWY_CORR_SEARCH_HEIGHT_DIFF | Mean values of data and kernel are adjusted before summing the squared differences. |
GWY_CORR_SEARCH_HEIGHT_DIFF_SCORE | In addition, result is normalised by dividing by the local variance. |

Since: 2.50

### enum GwyGrainQuantity

Grain quantity to request from `gwy_data_field_grains_get_distribution()` and similar functions.

#### Members

GWY_GRAIN_VALUE_PROJECTED_AREA | Projected (flat) grain area. |
GWY_GRAIN_VALUE_EQUIV_SQUARE_SIDE | Side of a square with the same area as the grain. |
GWY_GRAIN_VALUE_EQUIV_DISC_RADIUS | Radius of a disc with the same area as the grain. |
GWY_GRAIN_VALUE_SURFACE_AREA | Surface area. |
GWY_GRAIN_VALUE_MAXIMUM | Minimum value. |
GWY_GRAIN_VALUE_MINIMUM | Maximum value. |
GWY_GRAIN_VALUE_MEAN | Mean value. |
GWY_GRAIN_VALUE_MEDIAN | Median value. |
GWY_GRAIN_VALUE_PIXEL_AREA | Flat grain area measured in pixels. This value is redundant but it is useful for filtering (Since 2.37). |
GWY_GRAIN_VALUE_HALF_HEIGHT_AREA | Projected area of the part of grain that is above the half-height, i.e. the height between the minimum and maximum (Since 2.8). |
GWY_GRAIN_VALUE_FLAT_BOUNDARY_LENGTH | Length of projected grain boundary. Note for grains not topologically equivalent to disc, only the length of the outer boundary is calculated. |
GWY_GRAIN_VALUE_RMS | Standard deviation of grain values. (Since 2.51) |
GWY_GRAIN_VALUE_MINIMUM_BOUND_SIZE | Minimum lateral bounding size, in other words the minimum length of grain projection to any line in the horizontal plane. |
GWY_GRAIN_VALUE_MINIMUM_BOUND_ANGLE | Direction of the minimum lateral bounding size (arbitrary one if the minimum is not unique). |
GWY_GRAIN_VALUE_MAXIMUM_BOUND_SIZE | Maximum lateral bounding size, in other words the maximum length of grain projection to any line in the horizontal plane. |
GWY_GRAIN_VALUE_MAXIMUM_BOUND_ANGLE | Direction of the maximum lateral bounding size (arbitrary one if the maximum is not unique). |
GWY_GRAIN_VALUE_CENTER_X | Grain centre horizontal position, i.e. the mean value of its physical x-coordinates. (Since 2.7) |
GWY_GRAIN_VALUE_CENTER_Y | Grain centre vertical position, i.e. the mean value of its physical y-coordinates. (Since 2.7) |
GWY_GRAIN_VALUE_VOLUME_0 | Grain volume calculated with grain basis at `z` =0 (therefore it is just an integral it can be negative). (Since 2.3) |
GWY_GRAIN_VALUE_VOLUME_MIN | Grain volume calculated with grain basis at grain minimum value. This value is a lower bound. (Since 2.3) |
GWY_GRAIN_VALUE_VOLUME_LAPLACE | Grain volume calculated with grain basis calculated by laplacian interpolation of surrounding values. (Since 2.3) |
GWY_GRAIN_VALUE_SLOPE_THETA | Spherical angle theta of grain normal (0 is upwards). (Since 2.7) |
GWY_GRAIN_VALUE_SLOPE_PHI | Spherical angle phi of grain normal (0 is in positive x direction). (Since 2.7) |
GWY_GRAIN_VALUE_BOUNDARY_MAXIMUM | Maximum value in the grain inner boundary. (Since 2.12) |
GWY_GRAIN_VALUE_BOUNDARY_MINIMUM | Minimum value on the grain inner boundary. (Since 2.12) |
GWY_GRAIN_VALUE_CURVATURE_CENTER_X | Grain curvature centre horizontal position. For too small or flat grains it reduces to the horizontal position of geometrical centre. (Since 2.22) |
GWY_GRAIN_VALUE_CURVATURE_CENTER_Y | Grain curvature centre vertical position. For too small or flat grains it reduces to the vertical position of geometrical centre. (Since 2.22) |
GWY_GRAIN_VALUE_CURVATURE_CENTER_Z | The value at curvature centre. Note this is the value in the origin of the fitted quadratic surface, not at the real surface. (Since 2.22) |
GWY_GRAIN_VALUE_CURVATURE1 | Smaller grain curvature. (Since 2.22) |
GWY_GRAIN_VALUE_CURVATURE2 | Larger grain curvature. (Since 2.22) |
GWY_GRAIN_VALUE_CURVATURE_ANGLE1 | Direction of the smaller grain curvature radius. If the grain is flat or too small the angle is reported as 0. (Since 2.22) |
GWY_GRAIN_VALUE_CURVATURE_ANGLE2 | Direction of the larger grain curvature radius. If the grain is flat or too small the angle is reported as π/2. (Since 2.22) |
GWY_GRAIN_VALUE_INSCRIBED_DISC_R | Radius of maximum disc that fits inside the grain (Since 2.30) |
GWY_GRAIN_VALUE_INSCRIBED_DISC_X | Real X-coordinate of the centre of the maximum inscribed disc. (Since 2.30) |
GWY_GRAIN_VALUE_INSCRIBED_DISC_Y | Real Y-coordinate of the centre of the maximum inscribed disc. (Since 2.30) |
GWY_GRAIN_VALUE_CONVEX_HULL_AREA | Projected (flat) area of grain convex hull. (Since 2.30) |
GWY_GRAIN_VALUE_CIRCUMCIRCLE_R | Radius of minimum circle containing the grain. (Since 2.30) |
GWY_GRAIN_VALUE_CIRCUMCIRCLE_X | Real X-coordinate of the centre of the minimum circumcircle. (Since 2.30) |
GWY_GRAIN_VALUE_CIRCUMCIRCLE_Y | Real Y-coordinate of the centre of the minimum circumcircle. (Since 2.30) |
GWY_GRAIN_VALUE_MEAN_RADIUS | Mean distance from boundary to the grain centre as defined by `GWY_GRAIN_VALUE_CENTER_X` and `GWY_GRAIN_VALUE_CENTER_Y` . (Since 2.30) |
GWY_GRAIN_VALUE_EQUIV_ELLIPSE_MAJOR | Length of major semiaxis of equivalent ellipse. (Since 2.36) |
GWY_GRAIN_VALUE_EQUIV_ELLIPSE_MINOR | Length of minor semiaxis of equivalent ellipse. (Since 2.36) |
GWY_GRAIN_VALUE_EQUIV_ELLIPSE_ANGLE | Orientation of the major axis of equivalent ellipse. (Since 2.36) |
GWY_GRAIN_VALUE_MINIMUM_MARTIN_DIAMETER | Minimum value of Martin diameter. (Since 2.50) |
GWY_GRAIN_VALUE_MINIMUM_MARTIN_ANGLE | Direction corresponding to minimum Martin diameter. (Since 2.50) |
GWY_GRAIN_VALUE_MAXIMUM_MARTIN_DIAMETER | Maximum value of Martin diameter. (Since 2.50) |
GWY_GRAIN_VALUE_MAXIMUM_MARTIN_ANGLE | Direction corresponding to maximum Martin diameter. (Since 2.50) |

### enum GwyDataCompatibilityFlags

Data line, field, brick and lawn compatibility flags.

It is not recommended to pass `GWY_DATA_COMPATIBILITY_ALL` to checking functions since not all flags are meaningful for all data objects (even though meaningless flags are generally silently ignored).

#### Members

GWY_DATA_COMPATIBILITY_RES | Pixel sizes. |
GWY_DATA_COMPATIBILITY_REAL | Real (physical) dimensions. |
GWY_DATA_COMPATIBILITY_MEASURE | Real to pixel ratios. |
GWY_DATA_COMPATIBILITY_LATERAL | Units of lateral dimensions. |
GWY_DATA_COMPATIBILITY_VALUE | Units of values (for all curves in the case of lawns). |
GWY_DATA_COMPATIBILITY_AXISCAL | Axis calibrations. At present it only makes sense for GwyBrick which can have Z-calibrations. (Since 2.51) |
GWY_DATA_COMPATIBILITY_NCURVES | Number of lawn curves. (Since 2.60) |
GWY_DATA_COMPATIBILITY_CURVELEN | Lengths of curves in all lawn pixels. (Since 2.60) |
GWY_DATA_COMPATIBILITY_ALL | Mask of all defined flags. |

### enum GwyLineStatQuantity

Line statistical quantities to be requested with `gwy_data_field_area_get_line_stats()`.

#### Members

GWY_LINE_STAT_MEAN | Mean value. |
GWY_LINE_STAT_MEDIAN | Median. |
GWY_LINE_STAT_MINIMUM | Minimum value. |
GWY_LINE_STAT_MAXIMUM | Maximum value. |
GWY_LINE_STAT_RMS | Root mean square of deviations from the mean value. |
GWY_LINE_STAT_LENGTH | Line length. |
GWY_LINE_STAT_SLOPE | Overall line slope. |
GWY_LINE_STAT_TAN_BETA0 | Root mean square slope. |
GWY_LINE_STAT_RA | Arithmetic mean surface roughness. |
GWY_LINE_STAT_RZ | Maximum height of the roughness profile. |
GWY_LINE_STAT_RT | Total height of the roughness profile. |
GWY_LINE_STAT_SKEW | Line skew. |
GWY_LINE_STAT_KURTOSIS | Line excess kurtosis (which is 0 for a Gaussaian distrubution, not 3). |
GWY_LINE_STAT_RANGE | Difference between maximum and minimum value (Since 2.42). |
GWY_LINE_STAT_VARIATION | Variation (integral of absolute value) (Since 2.42). |
GWY_LINE_STAT_MINPOS | Minimum position along the line (Since 2.48). |
GWY_LINE_STAT_MAXPOS | Maximum position along the line (Since 2.48). |

Since: 2.2

### enum GwyExteriorType

Methods to handle pixels outside data.

Many methods currently use a fixed metod of handling of exterior pixels, for example area calculation uses extension (border and mirror coincide), convolution uses mirror extension, rotation fills exterior with a fixed value.

#### Members

GWY_EXTERIOR_UNDEFINED | The values corresponding to or calculated from exterior data values are undefined, they may be left unset or set to bogus values. The caller must handle them itself afterwards, for instance by resizing the result to consist of valid data only. |
GWY_EXTERIOR_BORDER_EXTEND | Values of exterior pixels are considered to be equal to the values of the nearest interior pixels. |
GWY_EXTERIOR_MIRROR_EXTEND | The data is considered to be periodically repeated, with odd instances reflected (the total period is thus twice the size of the data). |
GWY_EXTERIOR_PERIODIC | The data is considered to be periodically repeated. |
GWY_EXTERIOR_FIXED_VALUE | Values of exterior pixels are considered to be all equal to a user-specified value. |
GWY_EXTERIOR_LAPLACE | Values of exterior pixels are extended using Laplace interpolation (actually extrapolation) like `gwy_data_field_laplace_solve()`. Only some functions implement this method. (Since 2.50) |

Since: 2.2

### enum GwyDistanceTransformType

Type of distance transform.

#### Members

GWY_DISTANCE_TRANSFORM_CITYBLOCK | City-block distance (sum of horizontal and vertical distances). |
GWY_DISTANCE_TRANSFORM_CONN4 | Four-connectivity distance; another name for city-block distance. |
GWY_DISTANCE_TRANSFORM_CHESS | Chessboard distance (maximum of horizontal and vertical distance). |
GWY_DISTANCE_TRANSFORM_CONN8 | Eight-connectivity distance; another name for chessboard distance. |
GWY_DISTANCE_TRANSFORM_OCTAGONAL48 | Octagonal distance beginning from city-block. |
GWY_DISTANCE_TRANSFORM_OCTAGONAL84 | Octagonal distance beginning from chess. |
GWY_DISTANCE_TRANSFORM_OCTAGONAL | Average octagonal distance, i.e. the mean of the 48 and 84 distances (Since 2.43). |
GWY_DISTANCE_TRANSFORM_EUCLIDEAN | True Euclidean distance (Since 2.43). |

Since: 2.41

### enum GwyMinMaxFilterType

Type of operation based on morphological filters with flat structuring elements.

#### Members

GWY_MIN_MAX_FILTER_MINIMUM | Minimum filter, i.e. minimum of the surrounding values. |
GWY_MIN_MAX_FILTER_EROSION | Another name for the minimum filter. |
GWY_MIN_MAX_FILTER_MAXIMUM | Maximum filter, i.e. maximum of the surrounding values. |
GWY_MIN_MAX_FILTER_DILATION | Another name for the maximum filter. |
GWY_MIN_MAX_FILTER_OPENING | Morphological opening filter. |
GWY_MIN_MAX_FILTER_CLOSING | Morphological closing filter. |
GWY_MIN_MAX_FILTER_RANGE | Difference between maximum and minimum. |
GWY_MIN_MAX_FILTER_NORMALIZATION | Data value rescaled to the range between minimum and maximum. |

Since: 2.43

### enum GwyRotateResizeType

Type of rotated data field size determination method.

#### Members

GWY_ROTATE_RESIZE_SAME_SIZE | The result has the same area as the original. |
GWY_ROTATE_RESIZE_EXPAND | The result is sufficiently large so that all original data are present (usually meaning that there will be also lot of exterior). |
GWY_ROTATE_RESIZE_CUT | The result is optimally cut to interior data only. |

Since: 2.46

### enum GwyAffineScalingType

Type of lattice vector scaling in affine transform preparation.

#### Members

GWY_AFFINE_SCALING_AS_GIVEN | Correct lattice vectors lengths are taken as given. |
GWY_AFFINE_SCALING_PRESERVE_AREA | Correct lattice vectors are scaled to make the transformation area-preserving. |
GWY_AFFINE_SCALING_PRESERVE_X | Correct lattice vectors are scaled to preserve the scale along `x` -axis. |

Since: 2.49

### enum GwyBrickTransposeType

Type of volume data transposition.

The enum values names spell which old axis becomes which new axes.

#### Members

GWY_BRICK_TRANSPOSE_XYZ | No change (useful with axis flipping). |
GWY_BRICK_TRANSPOSE_XZY | Axes Z and Y are swapped. |
GWY_BRICK_TRANSPOSE_YXZ | Axes Y and Z are swapped. |
GWY_BRICK_TRANSPOSE_YZX | Axis X becomes Y, Y becomes Z and Z becomes X. |
GWY_BRICK_TRANSPOSE_ZXY | Axes X and Z are swapped. |
GWY_BRICK_TRANSPOSE_ZYX | Axis X becomes Z, Y becomes X and Z becomes Y. |

Since: 2.51

### GwyComputationState

    typedef struct {
        guint state;
        gdouble fraction;
    } GwyComputationState;

State of iterative computation.

Iterators usually append their own private state data, therefore it must not be assumed the public fields `state` and `fraction` are the only fields.

A typical iteration, assuming an iterative computation `foo' with the default GwyComputationStateType state could be:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    GwyComputationStateType *state;

    state = gwy_data_field_foo_init(GwyDataField *data_field, ...);
    do {
        gwy_data_field_foo_iteration(state);
        /* Update progress using state->fraction,
            let Gtk+ main loop run, check for abort, ... */
        if (aborted) {
            gwy_data_field_foo_finalize(state);
            return FALSE;
        }
    } while (state->state != GWY_COMPUTATION_STATE_FINISHED);
    gwy_data_field_foo_finalize(state);
    return TRUE;

#### Members

guint `state`; | Current computation state, usually of GwyComputationStateType, but particular iterators can define their own types. |
gdouble `fraction`; | Fraction of computation completed. For staged algorithms, the fraction refers to the current stage only. |